/*****************************************************************************/
/*                                                                           */
/* FILENAME                                                                  */
/* 	 main.c                                                                  */
/*                                                                           */
/* DESCRIPTION                                                               */
/*   TMS320C5515 USB Stick Application 20 Spectrum Analyser.                 */
/*   Take microphone input and send to headphones with ring modulation.      */
/*                                                                           */
/* REVISION                                                                  */
/*   Revision: 1.00	                                                         */
/*   Author  : Richard Sikora                                                */
/*---------------------------------------------------------------------------*/
/*                                                                           */
/* HISTORY                                                                   */
/*   Revision: 1.00                                                          */
/*   15th September 2010. Created from TMS320C5505 USB Stick code.           */
/*                                                                           */
/*****************************************************************************/
/*
 * Copyright (C) 2010 Texas Instruments Incorporated - http://www.ti.com/ 
 * 
 * 
 *  Redistribution and use in source and binary forms, with or without 
 *  modification, are permitted provided that the following conditions 
 *  are met:
 *
 *    Redistributions of source code must retain the above copyright 
 *    notice, this list of conditions and the following disclaimer.
 *
 *    Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the 
 *    documentation and/or other materials provided with the   
 *    distribution.
 *
 *    Neither the name of Texas Instruments Incorporated nor the names of
 *    its contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
 *  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
 *  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 *  A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT 
 *  OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
 *  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT 
 *  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 *  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 *  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT 
 *  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE 
 *  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
*/

#include "stdio.h"
#include "usbstk5515.h"
#include "usbstk5515_led.h"
#include "aic3204.h"
#include "PLL.h"
#include "oled.h"
#include "pushbuttons.h"
#include "stereo.h"
#include "dsplib.h"

#include <math.h>
#include "sar.h"

#include "IIR.h"

Int16 left_input;
Int16 right_input;
Int16 left_output;
Int16 right_output;
Int16 mono_input;


Int16 PSK;
Int16 PSK_stare0;
Int16 PSK_stare;
Int16 kwadrat;
Int16 kwadrat_filtr;
Int16 znak = 1; 
Int16 wartosc = 30000;
Int16 nosna_prostokat = 0;
Int16 nosna_sin = 0;
Int16 PSK_x_nosna;
Int16 PSK_x_puls;
Int16 dem_PSK;
Int16 dem_PSK_bity;


#define SAMPLES_PER_SECOND 48000
#define GAIN_IN_dB 0

// Filtr dopasowany

#define N_Avg 32						// SAMPLES_PER_SECOND / 100

DATA H_Avg[N_Avg];
DATA buforAvg[N_Avg + 2];

int probkiNaBit = 32;

unsigned long int k = 0;

unsigned int Step = 0; 
unsigned int LastStep = 99;

int fo = 3000;	// Częstotliwość nośna zmieniana nie tu a poniżej
int SR = 1500;  // Szybkość transmisji symboli
int B3dB = 500;
int f3db = 750;

char *napis1 = "1                   ";
char *napis2 = "2                   ";

signed int bufor[2];

signed int wsp_BPx2[6] = {0, 0, 0, 0, 0, 0 };
signed int x_BPx2[3] = { 0, 0, 0 };  // próbki wejściowe
signed int y_BPx2[3] = { 0, 0, 0 };  // próbki wyjściowe

signed int wsp_BP[6] = {0, 0, 0, 0, 0, 0 };
signed int x_BP[3] = { 0, 0, 0 };  // próbki wejściowe
signed int y_BP[3] = { 0, 0, 0 };  // próbki wyjściowe

signed int wsp_LP_out[6] = {0, 0, 0, 0, 0, 0 };
signed int x_LP[3] = { 0, 0, 0 };  // próbki wejściowe
signed int y_LP[3] = { 0, 0, 0 };  // próbki wyjściowe

unsigned int index = 0;

/* ------------------------------------------------------------------------ *
 *                                                                          *
 *  main( )                                                                 *
 *                                                                          *
 * ------------------------------------------------------------------------ */
void main( void ) 
 {
    /* Initialize BSL */
    USBSTK5515_init( );
	
	/* Initialize PLL */
	pll_frequency_setup(120);

    /* Initialise hardware interface and I2C for code */
    aic3204_hardware_init();
    
    /* Initialise the AIC3204 codec */
	aic3204_init(); 
	
	/* Turn off the 4 coloured LEDs */
	USBSTK5515_ULED_init();
	
	/* Initialise the OLED LCD display */
	oled_init();
	SAR_init();
	/* Flush display buffer */
    oled_display_message("                 ", "                   ");
    
    printf("\n\nLaboratorium FCiPS\n");
    printf( "Ćwiczenie Demodulatory\n\n" );
    printf( "Asynchroniczny demodulator BPSK\n" );
	printf( "Sygnał BPSK podawany z generatora na wejście kanału lewego ----->\n" );

	/* Setup sampling frequency and  gain for microphone */
    set_sampling_frequency_and_gain(SAMPLES_PER_SECOND, GAIN_IN_dB);

    oled_display_message("Application 20     ", "Spectrum Analyser  ");


      
	/* Default to XF LED off */
	asm(" bclr XF");    
    
 	for ( ;; )
 	{

     aic3204_codec_read(&left_input, &right_input); // Configured for one interrupt per two channels.  
     
     // demodulacja PSK
     PSK = left_input;

     kwadrat = _smpy(bufor[index], bufor[index]);
     kwadrat = _sshl(kwadrat - (1 << 14), 1);
         
     bufor[index] = PSK;    			// przesunięcie fazy o 90 deg
     if(fo==3000) index = ++index % 2;  // index = ++index % length;
     if(fo==6000) index = ++index % 1;  // index = ++index % length;   
      
     //filtracja kwadratu nośnej        
     kwadrat_filtr = SOS_Q14(x_BPx2, y_BPx2, wsp_BPx2, kwadrat);
         
     if(znak * kwadrat_filtr < 0 )		// dzielnik częstotliwości
     {
      	if(znak >= 0) wartosc = -wartosc;   
      	znak = -znak;
     }
          
    nosna_prostokat = wartosc;
    
    //filtracja kwadratu nośnej    
    nosna_sin = SOS_Q14(x_BP, y_BP, wsp_BP, nosna_prostokat);
      
    PSK_x_puls = ((long)PSK * nosna_prostokat) >> 15; // można 14 aby zwiększyć sygnał
           
	PSK_x_nosna = ((long)PSK * nosna_sin) >> 15;

	// I wariant filtru LP 	
	//dem_PSK =  IIR_I_order(x_LP, y_LP, wsp_LP_out, PSK_x_puls);
			
	// II wariant filtru LP - filtr dopasowany do sygnału
    fir(&PSK_x_puls, H_Avg, &dem_PSK, buforAvg, 1, probkiNaBit);  // filtr dopasowany
	
	if(dem_PSK > 0) dem_PSK_bity = 20000; else dem_PSK_bity = -20000;
        
     Step = pushbuttons_read(9);
  
	  if ( Step == 1 )
        {
         if ( Step != LastStep )
          {

			printf("Podaj częstotliwość nośną 3000 lub 6000 [Hz] fo = ");
    		scanf("%d", &fo);
    		printf("Podaj szybkość transmisji symboli [Bd] = ");
    		scanf("%d", &SR);
          	
    		B3dB = 200;
		    // projekt filtru BP(2*fo)
		    wsp_SOS_BP_Q14(2*fo, B3dB, SAMPLES_PER_SECOND, wsp_BPx2);
		       
		    // projekt filtru BP(2*fo)
		    wsp_SOS_BP_Q14(fo, B3dB, SAMPLES_PER_SECOND, wsp_BP);	
		    
		    // projekt filtru LP
		    wsp_LP(SR / 2, SAMPLES_PER_SECOND, wsp_LP_out);
		    
		    // projekt filtru dopasowanego
		    probkiNaBit = SAMPLES_PER_SECOND / SR;		    
		    for(k = 0; k < probkiNaBit; k++)
		    	H_Avg[k] = 32000 / probkiNaBit;
                    	
           oled_display_message("L = PSK           ", "P = kwadrat       ");
           printf( "1 Sygnały wyjściowe \nKanał lewy --> sygnał PSK \nKanał prawy -> PSK * PSK\n" );
           
           LastStep = Step;
          }	
         left_output = PSK;      // Straight trough. No processing.
	     right_output = kwadrat;
	    }
	    
	    if ( Step == 2)
        {
         if ( Step != LastStep )
          {
           oled_display_message("L = kwadrat       ", "P = kwadrat filtr.");
           printf( "2 Sygnały wyjściowe \nKanał lewy --> PSK * PSK\nKanał prawy -> Odfiltrowany filtrem BP PSK * PSK\n" );
           LastStep = Step;
          }	
         left_output = kwadrat;     // 
	     right_output = kwadrat_filtr;	// 
	    }
	     
	    if ( Step == 3)
        {
         if ( Step != LastStep )
          {
            oled_display_message("L = nosna puls    ", "P = kwadrat filtr."); 
            printf( "3 Sygnały wyjściowe \nKanał lewy --> Nośna prostokątna - częstotliwość kawdratu PSK podzielona przez 2 \nKanał prawy -> Odfiltrowany filtrem BP iloczyn PSK * PSK\n" );         
            LastStep = Step;
          }         
         left_output = nosna_prostokat;
	     right_output = kwadrat_filtr;	// 
	    }
	     
	    if ( Step == 4)
        {
         if ( Step != LastStep )
          {
            oled_display_message("L = PSK           ", "P = nosna sin     ");
            printf( "4 Sygnały wyjściowe \nKanał lewy --> sygnał PSK \nKanał prawy -> Nośna sinusoidalna\n" );          
            LastStep = Step;
          }         
         left_output = PSK;
	     right_output = nosna_sin;	// 
	    }
	     
	    if ( Step == 5)
        {
         if ( Step != LastStep )
          {
            oled_display_message("L = nosna puls    ", "P = nosna sin     ");
            printf( "5 Sygnały wyjściowe \nKanał lewy --> Nośna prostokątna \nKanał prawy -> Nośna sinusoidalna\n" );          
            LastStep = Step;
          }         
         left_output = nosna_prostokat;
	     right_output = nosna_sin;	// 
	    } 
	     
	    if ( Step == 6)
        {
         if ( Step != LastStep )
          {
            oled_display_message("L = PSK           ", "P = PSK_x_nosna    ");
            printf( "6 Sygnały wyjściowe \nKanał lewy --> sygnał PSK \nKanał prawy -> PSK * nośna sinusoidalna\n" );         
            LastStep = Step;
          }         
         left_output = PSK;
	     right_output = PSK_x_nosna;	// 
	    } 
	    
	    if ( Step == 7)
        {
         if ( Step != LastStep )
          {
            oled_display_message("L = PSK x puls    ", "P = PSK_x_nosna    ");
            printf( "7 Sygnały wyjściowe \nKanał lewy --> PSK * nośna prostokątna \nKanał prawy -> PSK * nośna sinusoidalna\n" );          
            LastStep = Step;
          }         
         left_output = PSK_x_puls;
	     right_output = PSK_x_nosna;	// 
	    } 
	    
	    if ( Step == 8)
        {
         if ( Step != LastStep )
          {
            oled_display_message("L = dem psk filtr ", "P = PSK_x_nosna    ");
            printf( "8 Sygnały wyjściowe \nKanał lewy --> PSK * nośna sinusoidalna \nKanał prawy -> PSK * nośna po filtracji LP\n" );          
            LastStep = Step;
          }         
         left_output = PSK_x_nosna;
	     right_output = dem_PSK;	// 
	    } 
	    
	    if ( Step == 9)
        {
         if ( Step != LastStep )
          {
            oled_display_message("L = dem psk filtr ", "P = dem psk bity  ");
            printf( "9 Sygnały wyjściowe \nKanał lewy --> PSK * nośna po filtracji LP \nKanał prawy -> PSK * nośna po filtracji LP i progowaniu\n" );          
            LastStep = Step;
          }         
         left_output = dem_PSK;
	     right_output = dem_PSK_bity;	// 
	    } 
	    
     aic3204_codec_write(left_output, right_output);

 	}

   /* Disable I2S and put codec into reset */ 
    aic3204_disable();

    printf( "\n***Program has Terminated***\n" );
    
    oled_display_message("PROGRAM HAS        ", "TERMINATED        ");
    
    SW_BREAKPOINT;
}

/* ------------------------------------------------------------------------ *
 *                                                                          *
 *  End of main.c                                                           *
 *                                                                          *
 * ------------------------------------------------------------------------ */
